8f0edfb558ffd6ef4bbe24caf8acc210629c11ae
[matthijs/upstream/backupninja.git] / handlers / rdiff
1 # -*- mode: sh; sh-basic-offset: 3; indent-tabs-mode: nil; -*-
2 #
3 # rdiff-backup handler script for backupninja
4 # requires rdiff-backup
5 #
6
7 ### FUNCTIONS ###
8
9 function test_connection() {
10         # given a user and host,
11         # tests the connection.
12         # if user or host is missing, returns 0
13         # (ie, assume it's a local connection).
14         if [ $# -lt 2 ]; then
15                 debug "(local is assumed to be a good connection)"
16                 return 0
17         fi
18         local user=$1
19         local host=$2
20         debug "ssh -o PasswordAuthentication=no $host -l $user 'echo -n 1'"
21         local ret=`ssh -o PasswordAuthentication=no $host -l $user 'echo -n host is alive'`
22         if echo $ret | grep "host is alive"; then
23                 debug "Connected to $host as $user successfully"
24         else
25                 fatal "Can't connect to $host as $user."
26         fi
27 }
28
29 function get_version() {
30         # given no arguments, returns the local version.
31         # given a user and host, returns the remote version.
32         # if user or host is missing, returns the local version.
33         if [ "$#" -lt 2 ]; then
34                 debug "$RDIFFBACKUP -V"
35                 echo `$RDIFFBACKUP -V`
36         else
37                 local user=$1
38                 local host=$2
39                 debug "ssh $host -l $user '$RDIFFBACKUP -V'"
40                 echo `ssh $host -l $user "$RDIFFBACKUP -V | grep rdiff-backup"`
41         fi
42 }
43
44 function check_consistency() {
45         local section=$1
46         local type=$2
47         local user=$3
48         local host=$4
49         if [ "$type" == "local" ]; then
50                 if [ "$user" != "" ]; then
51                         warning "User should not be specified for local $section."
52                 fi
53                 if [ "$host" != "" ]; then
54                         warning "Host should not be specified for local $section."
55                 fi
56         fi
57         if [ "$type" == "remote" ]; then
58                 if [ "$user" == "" ]; then
59                         fatal "User must be specified for remote $section."
60                 fi
61                 if [ "host" == "" ]; then
62                         fatal "Host must be specifed for remote $section."
63                 fi
64         fi
65 }
66
67 ### GET CONFIG ###
68
69 getconf options
70 getconf testconnect yes
71 getconf nicelevel 0
72
73 setsection source
74 getconf type; sourcetype=$type
75 getconf user; sourceuser=$user
76 getconf host; sourcehost=$host
77 check_consistency "source" "$type" "$user" "$host"
78 getconf label
79 getconf keep 60
80 getconf include
81 getconf vsnames all
82 getconf vsinclude
83 getconf exclude
84
85 setsection dest
86 getconf directory; destdir=$directory
87 # strip trailing /
88 destdir=${destdir%/}
89 getconf type; desttype=$type
90 getconf user; destuser=$user
91 getconf host; desthost=$host
92 check_consistency "destination" "$type" "$user" "$host"
93
94 ### CHECK CONFIG ###
95
96 # If vservers are configured, check that the ones listed in $vsnames do exist.
97 local usevserver=no
98 if [ $vservers_are_available = yes ]; then
99    if [ "$vsnames" = all ]; then
100       vsnames="$found_vservers"
101    else
102       if ! vservers_exist "$vsnames" ; then
103             fatal "At least one of the vservers listed in vsnames ($vsnames) does not exist."
104       fi
105    fi
106    if [ -n "$vsinclude" ]; then
107       info "Using vservers '$vsnames'"
108       usevserver=yes
109    fi
110 else
111    [ -z "$vsinclude" ] || warning 'vservers support disabled in backupninja.conf, vsincludes configuration lines will be ignored'
112 fi
113
114 # check the connection at the source and destination
115 [ -n "$test" ] || test=0
116 if [ "$testconnect" = "yes" ] || [ "${test}" -eq 1 ]; then
117         test_connection $sourceuser $sourcehost
118         test_connection $destuser $desthost
119 fi
120
121 # see that rdiff-backup has the same version at the source and destination
122 sourceversion=`get_version $sourceuser $sourcehost`
123 destversion=`get_version $destuser $desthost`
124 if [ "$sourceversion" != "$destversion" ]; then
125         fatal "rdiff-backup does not have the same version at the source and at the destination."
126 fi
127
128 # source specific checks
129 [ "$include" != "" -o "$vsinclude" != "" ] || fatal "No source includes specified"
130 case $sourcetype in 
131         remote ) execstr_sourcepart="$sourceuser@$sourcehost::/" ;;
132         local  ) execstr_sourcepart="/" ;;
133         *      ) fatal "sourcetype '$sourcetype' is neither local nor remote" ;;
134 esac
135
136 # destination specific checks
137 [ "$destdir" != "" ] || fatal "Destination directory not set"
138 case $desttype in 
139         remote ) execstr_destpart="$destuser@$desthost::$destdir/$label" ;;
140         local  ) execstr_destpart="$destdir/$label" ;;
141         *      ) fatal "desttype '$desttype' is neither local nor remote" ;;
142 esac
143         
144 ### REMOVE OLD BACKUPS ###
145
146 if [ "`echo $keep | tr -d 0-9`" == "" ]; then
147         # add D if no other date unit is specified
148         keep="${keep}D"
149 fi
150
151 removestr="$RDIFFBACKUP --force --remove-older-than $keep "
152 if [ "$desttype" == "remote" ]; then
153         removestr="${removestr}${destuser}@${desthost}::"
154 fi
155 removestr="${removestr}${destdir}/${label}";
156
157 debug "$removestr"
158 if [ ! $test ]; then
159         output=`$removestr 2>&1`
160         if [ $? = 0 ]; then
161                 debug $output
162                 info "Removing backups older than $keep days succeeded."
163         else
164                 warning $output
165                 warning "Failed removing backups older than $keep."
166         fi
167 fi
168
169 ### EXECUTE ###
170
171 execstr="$RDIFFBACKUP $options --print-statistics "
172
173 set -o noglob
174
175 symlinks_warning="Maybe you have mixed symlinks and '*' in this statement, which is not supported."
176
177 # TODO: order the includes and excludes
178 # excludes
179 for i in $exclude; do
180    str="${i//__star__/*}"
181    str=`readlink -f $str`
182    if [ -n "$str" ]; then
183       execstr="${execstr}--exclude '$str' "
184    else
185       warning "exclude statement ${i//__star__/*} will be ignored. $symlinks_warning"
186    fi
187 done
188 # includes 
189 for i in $include; do
190    [ "$i" != "/" ] || fatal "Sorry, you cannot use 'include = /'"
191    str="${i//__star__/*}"
192    str=`readlink -f $str`
193    if [ -n "$str" ]; then
194       execstr="${execstr}--include '$str' "
195    else
196       warning "include statement ${i//__star__/*} will be ignored. $symlinks_warning"
197    fi
198 done
199
200 # vsinclude
201 if [ $usevserver = yes ]; then
202    for vserver in $vsnames; do
203       for vi in $vsinclude; do
204          str="${vi//__star__/*}"
205          str=`readlink -f $VROOTDIR/$vserver$str`
206          if [ -n "$str" ]; then
207             execstr="${execstr}--include '$str' "
208          else
209             warning "vsinclude statement ${vi//__star__/*} will be ignored for VServer $vserver. $symlinks_warning"
210          fi
211       done
212    done
213 fi
214
215 set +o noglob
216
217 # exclude everything else
218 execstr="${execstr}--exclude '/*' "
219                 
220 # include client-part and server-part
221 execstr="${execstr}$execstr_sourcepart $execstr_destpart"
222
223 debug "$execstr"
224 if [ ! $test ]; then
225         output=`nice -n $nicelevel su -c "$execstr" 2>&1`
226         if [ $? = 0 ]; then
227                 debug $output
228                 info "Successfully finished backing up source $label"
229         else
230                 warning $output
231                 warning "Failed backup up source $label"
232         fi
233 fi      
234
235 return 0